//const e = React.createElement;
const Button = React.Component.Button;

//class EditButton extends React.Component {
//  constructor(props) {
//    super(props);
//  }

//  render() {
//    return e(
//      'button', { onClick: () => tmssFetch('project', this) }, 'Edit');
//  }
//}


const Tag = props => (
   <span className={props.tag == 'test' ? 'label label-info' : 'label label-default'}>{props.tag}</span>
)


const Project = props => (
    <tr className={props.project.expert ? 'warning' : ''}>
	<td>
          { props.project.tags.map(function(currentTag, i){return <Tag tag={currentTag} key={i} />}) }
        </td>
        <td>{props.project.cycle}</td>    
        <td>{props.project.name}</td>
        <td>{props.project.priority}</td>
        <td><button onClick={() => console.log('Edit ' + props.project.name)}>Edit</button></td>
    </tr>
)

class ProjectList extends React.Component {

    constructor(props) {
        super(props);
        this.state = {projects: []};
    }

    fetch_projects(){
        console.log('Fetching projects...')
        var headers = new Headers();
        headers.append('Authorization', 'Basic ' + btoa('paulus:pauluspass'));
        var response = fetch('http://localhost:8000/project/', {headers: headers})
          .then(response => response.json())
          .then(console.log(response))
          .then(response => this.setState({projects:response.results}))
          .catch(err => console.log(err))
    }

    componentDidMount(){
        this.fetch_projects();
    }

    projects() {
        return this.state.projects.map(function(currentProject, i){
            return <Project project={currentProject} key={i} />;
        })
    }

    render() {
        console.log("rendering... ");
        return (
            <div>
                <h3>Project List</h3>
                <table className="table table-striped table-bordered table-hover">
                    <thead>
                        <tr>
                            <th>Tags</th>
                            <th>Cycle</th>
                            <th>Name</th>
                            <th>Priority</th>
                            <th>Actions</th>
                        </tr>
                    </thead>
                    <tbody>
                        { this.projects() }
                    </tbody>
                </table>
            </div>
        )
    }
}

const domContainer = document.querySelector("#test_container");
ReactDOM.render(<ProjectList />, domContainer);
