import React, {Component} from 'react';
import { BrowserRouter as Router } from 'react-router-dom';

import {AppTopbar} from './layout/components/AppTopbar';
import {AppMenu} from './layout/components/AppMenu';
import { AppFooter } from './layout/components/AppFooter';
import {RoutedContent} from './routes';

// import {Dashboard} from './routes/dashboard/dashboard';

import './layout/layout.scss';
// import './App.css';


class App extends Component {

  constructor() {
    super();
    this.state = {
      currentMenu: '',
      currentPath: '/'
    }
    this.onMenuItemClick = this.onMenuItemClick.bind(this)
    this.menu = [
      {label: 'Dashboard', icon: 'pi pi-fw pi-home', to:'/dashboard'},
      {label: 'Scheduling Units', icon: 'pi pi-fw pi-calendar', to:'/scheduling'}
    ];

    // this.menuComponent = {'Dashboard': Dashboard}
  }

  onMenuItemClick(event) {
    console.log(event);
    this.setState({currentMenu:event.item.label, currentPath: event.item.path});
  }

  render() {
    return (
      <React.Fragment>
      <div className="App">
          
          <AppTopbar></AppTopbar>
          <Router basename={ this.state.currentPath }>
          <AppMenu model={this.menu} onMenuItemClick={this.onMenuItemClick} />
            <div className="layout-wrapper layout-static layout-static-sidebar-active">
              <div className="layout-main">
                
                  <RoutedContent />
                
              </div>
            </div>
          </Router>
          <AppFooter></AppFooter>
          
        
      </div>
      </React.Fragment>
    );
  }
}

export default App;
