"""
This file contains customized UI elements for use in the viewsets (based on the elsewhere defined data models and serializers)
"""
from rest_framework import serializers
import json


class JSONEditorField(serializers.JSONField):
    """
    An enhanced JSONfield that provides a nice editor widget with validation against the provided schema.
    """
    def __init__(self, schema, *args, **kwargs):
        kwargs['style'] = {'template': 'josdejong_jsoneditor_widget.html', 'schema': json.dumps(schema)}
        super().__init__(*args, **kwargs)
