// This is a simple proof of concept of a CRUD page without a proper toolchain, i.e. Bootstrap CSS, React, and Babel are not npm-managed and simply included via CDN.

// Shared Procedures

var headers = new Headers();
headers.append('Authorization', 'Basic ' + btoa('paulus:pauluspass'));
headers.append('Content-Type', 'application/json');

function tmssGetList(url, component){
   console.log('Getting '+ url)
   var response = fetch('http://localhost:8000/'+url, {headers: headers})
     .then(response => response.json())
     .then(response => {console.log(response);
                        component.setState({items:response.results});})
     .catch(err => console.log(err))
   }

function tmssGet(url, component){
   console.log('Getting '+ url)
   var response = fetch('http://localhost:8000/'+url, {headers: headers})
     .then(response => response.json())
     .then(response => {console.log(response);
                        component.setState(response);})
     .catch(err => console.log(err))
   }

function tmssPost(url, data, component){
   console.log('Posting '+ url)
   var response = fetch('http://localhost:8000/'+url, {headers: headers, method: 'POST', body: data})
     .then(ReactDOM.render(<ProjectList />, domContainer))
     .catch(err => console.log(err))
   }

function tmssPut(url, data, component){
   console.log('Putting '+ url)
   console.log(data)
   var response = fetch('http://localhost:8000/'+url, {headers: headers, method: 'PUT', body: data})
     .then(ReactDOM.render(<ProjectList />, domContainer))
     .catch(err => console.log(err))
   }

function tmssPatch(url, data, component){
   console.log('Patching '+ url)
   console.log(data)
   var response = fetch('http://localhost:8000/'+url, {headers: headers, method: 'PATCH', body: data})
     .then(ReactDOM.render(<ProjectList />, domContainer))
     .catch(err => console.log(err))
   }

function tmssDelete(url){
   console.log('Deleting '+ url)
   var response = fetch('http://localhost:8000/'+url, {headers: headers, method: 'DELETE'})
     .catch(err => console.log(err))
   }


// Components

const Tag = props => (
   <span className={props.tag == 'test' ? 'label label-info' : 'label label-default'}>{props.tag}</span>
)

const Project = props => (
    <tr className={props.project.expert ? 'warning' : ''}>
	<td>{props.project.tags.map(
          function(currentTag, i){
            return <Tag tag={currentTag} key={i} />
          }
        )}</td>
        <td><span className={props.project.filler ? "glyphicon glyphicon-ok" : "glyphicon glyphicon-remove"}></span></td>
        <td>{props.project.cycle}</td>    
        <td>{props.project.name}</td>
        <td>{props.project.priority}</td>
        <td>
          <button className="btn btn-primary" onClick={() => ReactDOM.render(<EditProject project={props.project.name}/>, domContainer)}>Edit</button>
          <button className="btn btn-danger"onClick={() => {
            tmssDelete('project/'+props.project.name);
            props.deleteItem(props.index);
          }}>Delete</button>
        </td>
    </tr>
)


// Main Components

class EditProject extends React.Component {

    constructor(props) {
        super(props);

        this.onChangeDescription = this.onChangeDescription.bind(this);
        this.onChangeCycle = this.onChangeCycle.bind(this);
        this.onChangePriority = this.onChangePriority.bind(this);
        this.onChangeIsFiller = this.onChangeIsFiller.bind(this);
        this.onSubmit = this.onSubmit.bind(this);

        this.state = { 
            isnew: props.isnew,
            project: props.project,
            name: props.project,
            tags: [],
            description: 'enter description here',
            cycle: '',
            priority: '1',
            filler: false,
            trigger: false,
            private: false,
            expert: false,
        }
    }

    componentDidMount() {
        if(!this.state.isnew){
    	    tmssGet('project/'+this.state.project+'/', this);
        }
    }

    onChangeDescription(e) {
        this.setState({
            description: e.target.value
        });
    }

    onChangeCycle(e) {
        this.setState({
            cycle: e.target.value
        });
    }

    onChangePriority(e) {
        this.setState({
            priority: e.target.value
        });
    }

    onChangeIsFiller(e) {
        this.setState({
            filler: !this.state.filler
        });
    }

    onSubmit(e) {
        e.preventDefault();
        const data = {
            name: this.state.name,
            tags: this.state.tags,
            description: this.state.description,
            cycle: this.state.cycle,
            priority: this.state.priority,
            filler: this.state.filler,
            trigger: this.state.filler,
            private: this.state.private,
            expert: this.state.expert,
        };
        if(this.state.isnew){
            tmssPost('project/', JSON.stringify(data), this)
        }else{
            tmssPut('project/'+this.props.project+'/', JSON.stringify(data), this)
        }
    }

    render() {
        return (
            <div>
                <h3 align="center">Edit Project</h3>
                <form onSubmit={this.onSubmit}>
                    <div className="form-group"> 
                        <label>Description: </label>
                        <input  type="text"
                                className="form-control"
                                value={this.state.description}
                                onChange={this.onChangeDescription}
                                />
                    </div>
                    <div className="form-group">
                        <label>Cycle: </label>
                        <input 
                                type="text" 
                                className="form-control"
                                value={this.state.cycle}
                                onChange={this.onChangeCycle}
                                />
                    </div>
                    <div className="form-group">
                        <label>
                            Priority:
                        </label>     
                        <input  className="form-control-range"
                                id="prioritySlider"
                                type="range"
                                name="prioritySlider"
                                value={this.state.priority}
                                onChange={this.onChangePriority}
                                />
                                           
                    </div>
                    <div className="form-check">
                        <input  className="form-check-input"
                                id="fillerCheckbox"
                                type="checkbox"
                                name="fillerCheckbox"
                                onChange={this.onChangeIsFiller}
                                checked={this.state.filler}
                                value={this.state.filler}
                                />
                        <label className="form-check-label" htmlFor="fillerCheckbox">
                            Filler
                        </label>                        
                    </div>

                    <br />

                    <div className="form-group">
                        <input type="submit" value="Submit" className="btn btn-primary" />
                    </div>
                </form>
            </div>
        )
    }
}

class ProjectList extends React.Component {

    constructor(props) {
        super(props);
        this.state = {items: []};
    }

    componentDidMount(){
        tmssGetList('project/', this);
    }

    deleteItem = (index) => {
        var itms = this.state.items;
        itms.splice(index, 1);
        this.setState( {items: itms} );
    }

    projects() {
        return this.state.items.map(
		(currentProject, i) => <Project project={currentProject} key={i} index={i} deleteItem={this.deleteItem} /> 
	);
    }

    render() {
        return (
            <div>
                <h3>Project List <button className="btn btn-primary" onClick={() => ReactDOM.render(<EditProject project={'default_name'} isnew={true} />, domContainer)}>Create New</button></h3> 
                <table className="table table-striped table-bordered table-hover">
                    <thead>
                        <tr>
                            <th>Tags</th>
			    <th>Filler</th>
                            <th>Cycle</th>
                            <th>Name</th>
                            <th>Priority</th>
                            <th>Actions</th>
                        </tr>
                    </thead>
                    <tbody>
                        { this.projects() }
                    </tbody>
                </table>
            </div>
        )
    }
}



// Render main React component in HTML container

const domContainer = document.querySelector("#test_container");
ReactDOM.render(<ProjectList />, domContainer);



