// This is a simple proof of concept of a CRUD page without a proper toolchain, i.e. Bootstrap CSS, React, and Babel are not npm-managed and simply included via CDN.

// Shared Procedures

function tmssGet(url, component){
   console.log('Fetching '+ url)
   var headers = new Headers();
   headers.append('Authorization', 'Basic ' + btoa('paulus:pauluspass'));
   var response = fetch('http://localhost:8000/'+url, {headers: headers})
     .then(response => response.json())
     .then(console.log(response))
     .then(response => component.setState({items:response.results}))
     .catch(err => console.log(err))
   }

function tmssDelete(url){
   console.log('Deleting '+ url)
   var headers = new Headers();
   headers.append('Authorization', 'Basic ' + btoa('paulus:pauluspass'));
   var response = fetch('http://localhost:8000/'+url, {headers: headers, method: 'DELETE'})
     .then(console.log(response))
     .catch(err => console.log(err))
   }


// Components

const Button = React.Component.Button;

const Tag = props => (
   <span className={props.tag == 'test' ? 'label label-info' : 'label label-default'}>{props.tag}</span>
)

const Project = props => (
    <tr className={props.project.expert ? 'warning' : ''}>
	<td>{props.project.tags.map(
          function(currentTag, i){
            return <Tag tag={currentTag} key={i} />
          }
        )}</td>
        <td><span className={props.project.filler ? "glyphicon glyphicon-ok" : "glyphicon glyphicon-remove"}></span></td>
        <td>{props.project.cycle}</td>    
        <td>{props.project.name}</td>
        <td>{props.project.priority}</td>
        <td>
          <button onClick={() => console.log(props.index)}>Edit</button>
          <button onClick={() => {
            tmssDelete('project/'+props.project.name);
            props.deleteItem(props.index);
          }}>Delete</button>
        </td>
    </tr>
)



// ---
class EditTodo extends React.Component {

    constructor(props) {
        super(props);

        this.onChangeTodoDescription = this.onChangeTodoDescription.bind(this);
        this.onChangeTodoResponsible = this.onChangeTodoResponsible.bind(this);
        this.onChangeTodoPriority = this.onChangeTodoPriority.bind(this);
        this.onChangeTodoCompleted = this.onChangeTodoCompleted.bind(this);
        this.onSubmit = this.onSubmit.bind(this);

        this.state = {
            todo_description: '',
            todo_responsible: '',
            todo_priority: '',
            todo_completed: false
        }
    }

    componentDidMount() {
        axios.get('http://localhost:4000/todos/'+this.props.match.params.id)
            .then(response => {
                this.setState({
                    todo_description: response.data.todo_description,
                    todo_responsible: response.data.todo_responsible,
                    todo_priority: response.data.todo_priority,
                    todo_completed: response.data.todo_completed
                })   
            })
            .catch(function (error) {
                console.log(error);
            })
    }

    onChangeTodoDescription(e) {
        this.setState({
            todo_description: e.target.value
        });
    }

    onChangeTodoResponsible(e) {
        this.setState({
            todo_responsible: e.target.value
        });
    }

    onChangeTodoPriority(e) {
        this.setState({
            todo_priority: e.target.value
        });
    }

    onChangeTodoCompleted(e) {
        this.setState({
            todo_completed: !this.state.todo_completed
        });
    }

    onSubmit(e) {
        e.preventDefault();
        const obj = {
            todo_description: this.state.todo_description,
            todo_responsible: this.state.todo_responsible,
            todo_priority: this.state.todo_priority,
            todo_completed: this.state.todo_completed
        };
        console.log(obj);
        axios.post('http://localhost:4000/todos/update/'+this.props.match.params.id, obj)
            .then(res => console.log(res.data));
        
        this.props.history.push('/');
    }

    render() {
        return (
            <div>
                <h3 align="center">Update Todo</h3>
                <form onSubmit={this.onSubmit}>
                    <div className="form-group"> 
                        <label>Description: </label>
                        <input  type="text"
                                className="form-control"
                                value={this.state.todo_description}
                                onChange={this.onChangeTodoDescription}
                                />
                    </div>
                    <div className="form-group">
                        <label>Responsible: </label>
                        <input 
                                type="text" 
                                className="form-control"
                                value={this.state.todo_responsible}
                                onChange={this.onChangeTodoResponsible}
                                />
                    </div>
                    <div className="form-group">
                        <div className="form-check form-check-inline">
                            <input  className="form-check-input" 
                                    type="radio" 
                                    name="priorityOptions" 
                                    id="priorityLow" 
                                    value="Low"
                                    checked={this.state.todo_priority==='Low'} 
                                    onChange={this.onChangeTodoPriority}
                                    />
                            <label className="form-check-label">Low</label>
                        </div>
                        <div className="form-check form-check-inline">
                            <input  className="form-check-input" 
                                    type="radio" 
                                    name="priorityOptions" 
                                    id="priorityMedium" 
                                    value="Medium" 
                                    checked={this.state.todo_priority==='Medium'} 
                                    onChange={this.onChangeTodoPriority}
                                    />
                            <label className="form-check-label">Medium</label>
                        </div>
                        <div className="form-check form-check-inline">
                            <input  className="form-check-input" 
                                    type="radio" 
                                    name="priorityOptions" 
                                    id="priorityHigh" 
                                    value="High" 
                                    checked={this.state.todo_priority==='High'} 
                                    onChange={this.onChangeTodoPriority}
                                    />
                            <label className="form-check-label">High</label>
                        </div>
                    </div>
                    <div className="form-check">
                        <input  className="form-check-input"
                                id="completedCheckbox"
                                type="checkbox"
                                name="completedCheckbox"
                                onChange={this.onChangeTodoCompleted}
                                checked={this.state.todo_completed}
                                value={this.state.todo_completed}
                                />
                        <label className="form-check-label" htmlFor="completedCheckbox">
                            Completed
                        </label>                        
                    </div>

                    <br />

                    <div className="form-group">
                        <input type="submit" value="Update Todo" className="btn btn-primary" />
                    </div>
                </form>
            </div>
        )
    }
}
// ---



// Main Component

class ProjectList extends React.Component {

    constructor(props) {
        super(props);
        this.state = {items: []};
    }

    componentDidMount(){
        tmssGet('project', this);
    }

    deleteItem = (index) => {
        var itms = this.state.items;
        itms.splice(index, 1);
        this.setState( {items: itms} );
    }

    projects() {
        return this.state.items.map(
		(currentProject, i) => <Project project={currentProject} key={i} index={i} deleteItem={this.deleteItem} /> 
	);
    }

    render() {
        return (
            <div>
                <h3>Project List</h3>
                <table className="table table-striped table-bordered table-hover">
                    <thead>
                        <tr>
                            <th>Tags</th>
			    <th>Filler</th>
                            <th>Cycle</th>
                            <th>Name</th>
                            <th>Priority</th>
                            <th>Actions</th>
                        </tr>
                    </thead>
                    <tbody>
                        { this.projects() }
                    </tbody>
                </table>
            </div>
        )
    }
}



// Render main React component in HTML container

const domContainer = document.querySelector("#test_container");
ReactDOM.render(<ProjectList />, domContainer);



